<?php
/*

Copyright 2020 Dario Curvino (email : d.curvino@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

if (!defined('ABSPATH')) {
    exit('You\'re not allowed to see this page');
} // Exit if accessed directly

?>

<div id="money_back_guarantee_cont">
    <section id="money_back_guarantee">
        <h1>
            <b class="stars">
                <i class="last">⋆</i>
                <i class="middle">⋆</i>
                <i class="first">⋆</i>
            </b>
            <span>7-Day Money Back Guarantee</span>
            <b class="stars">
                <i class="first">⋆</i>
                <i class="middle">⋆</i>
                <i class="last">⋆</i>
            </b>
        </h1>
        <p>
            You are fully protected by our 100% Money Back Guarantee. If during the next 7 days you experience an issue
            that makes the plugin unusable and we are unable to resolve it, we'll happily consider offering a full refund
            of your money. <a id="yasr-link-policy" href="#">Learn more...</a>
        </p>
    </section>
</div>

<div id="yasr-refund-policy-cont">
    <div id="yasr-refund-policy" class="yasr-refund-policy">
        <!-- Modal content -->
        <div id="yasr-modal-content">
            <span class="yasr-close-modal-policy" id="yasr-close-modal-policy">&times;</span>
            <header class="yasr-modal-header">
                <h2>Refund Policy</h2>
            </header>

            <p>
                We stand behind our plugin’s quality and your satisfaction with it is important to us. If you experience problems with the plugin, we will be happy to provide a full refund within 7 days of the original upgrade date.
            </p>
            <p>
                Refunds will be offered at our sole discretion and must meet all of the following conditions <b>fully</b>:
            </p>
            <ul>
                <li>You are within the first 7 days of the purchase of the plugin.</li>
                <li>Your issue(s) derives from not being able to install the plugin properly or get the plugin to perform its basic functions.</li>
                <li>You have attempted to resolve your issue(s) with our support team by opening a support ticket through the "Contact Us" in the plugin’s admin settings.</li>
                <li>No refunds will be granted after the first 7 days of the original purchase whatsoever.</li>
                <li>Refunds will not be granted for missing feature(s). If you are not sure we support a specific feature, please contact us first.</li>
                <li>Issues caused by conflicts with 3rd party plugins, themes or other software will not provide grounds for a refund.</li>
                <li>Refunds will not be granted if you simply decide not to use the plugin.</li>
            </ul>
            <p>By upgrading, you agree to this refund policy and relinquish any rights to subject it to any questions, judgment or legal actions.</p> <p>
            </p>
        </div>
    </div>
</div>

<div id="yasr-table-container">
</div>

<div id="yasr-pricing-faq">
    <div class="yasr-pricing-faq-row">
        <h2>Frequently Asked Questions</h2>
    </div>
    <div class="">
        <p>&nbsp;</p>
    </div>

    <div class="yasr-pricing-faq-row">
        <h3>Is there a setup fee?</h3>
        <p>No. There are no setup fees on any of our plans.</p>

        <h3>Can I cancel my account at any time?</h3>
        <p>Yes, if you ever decide that Yasr - Yet Another Stars Rating isn't the best plugin for your business, simply cancel your account from your Account panel.</p>

        <h3>What's the time span for your contracts?</h3>
        <p>All plans are month-to-month unless you subscribe for an annual or lifetime plan.</p>

        <h3>Do you offer any discounted plans?</h3>
        <p>Yes, as you can see in the table!</p>

        <h3>Can I change my plan later on?</h3>
        <p>Absolutely! You can upgrade or downgrade your plan at any time.</p>

        <h3>What payment methods are accepted?</h3>
        <p>We accept all major credit cards including Visa, Mastercard, American Express, as well as PayPal payments.</p>

        <h3>Do you offer refunds?</h3>
        <p><a href="#" id="yasr-link-policy-faq">Yes we do!</a> We stand behind the
            quality of our product and will refund 100% of your money if you experience an issue that makes
            the plugin unusable and we are unable to resolve it.
        </p>

        <h3>Do I get updates for the premium plugin?</h3>
        <p>Yes! Automatic updates to our premium plugin are available free of charge as long as you stay our paying customer.</p>

        <h3>Do you offer support if I need help?</h3>
        <p>Yes! Top-notch customer support for our paid customers is key for a quality product, so we'll do our very best to resolve any issues you encounter via our support page.</p>

        <h3>I have other pre-sale questions, can you help?</h3>
        <p>Yes! You can ask us any question writing at
            <a href="mailto:support@yetanotherstarsrating.com?subject=Presale%20Question">this link</a>.
        </p>
    </div>
</div>